The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

Public Member Functions | List of all members
stk::BiQuad Class Reference

STK biquad (two-pole, two-zero) filter class. More...

`#include <BiQuad.h>`

Inheritance diagram for stk::BiQuad:

## Public Member Functions
| BiQuad ()
| Default constructor creates a second-order pass-through filter.
| ~BiQuad ()
| Class destructor.
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.
void | setCoefficients (StkFloat b0, StkFloat b1, StkFloat b2, StkFloat a1, StkFloat a2, bool clearState=false)
| Set all filter coefficients.
void | setB0 (StkFloat b0)
| Set the b[0] coefficient value.
void | setB1 (StkFloat b1)
| Set the b[1] coefficient value.
void | setB2 (StkFloat b2)
| Set the b[2] coefficient value.
void | setA1 (StkFloat a1)
| Set the a[1] coefficient value.
void | setA2 (StkFloat a2)
| Set the a[2] coefficient value.
void | setResonance (StkFloat frequency, StkFloat radius, bool normalize=false)
| Sets the filter coefficients for a resonance at frequency (in Hz).
void | setNotch (StkFloat frequency, StkFloat radius)
| Set the filter coefficients for a notch at frequency (in Hz).
void | setLowPass (StkFloat fc, StkFloat Q=RECIP_SQRT_2)
| Set the filter coefficients for a low-pass with cutoff frequency fc (in Hz) and Q-factor Q.
void | setHighPass (StkFloat fc, StkFloat Q=RECIP_SQRT_2)
| Set the filter coefficients for a high-pass with cutoff frequency fc (in Hz) and Q-factor Q.
void | setBandPass (StkFloat fc, StkFloat Q)
| Set the filter coefficients for a band-pass centered at fc (in Hz) with Q-factor Q.
void | setBandReject (StkFloat fc, StkFloat Q)
| Set the filter coefficients for a band-reject centered at fc (in Hz) with Q-factor Q.
void | setAllPass (StkFloat fc, StkFloat Q)
| Set the filter coefficients for an all-pass centered at fc (in Hz) with Q-factor Q.
void | setEqualGainZeroes (void)
| Sets the filter zeroes for equal resonance gain.
StkFloat | lastOut (void) const
| Return the last computed output value.
StkFloat | tick (StkFloat input)
| Input one sample to the filter and return a reference to one output.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
StkFrames & | tick (StkFrames &iFrames, StkFrames &oFrames, unsigned int iChannel=0, unsigned int oChannel=0)
| Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.
Public Member Functions inherited from stk::Filter
| Filter (void)
| Class constructor.
unsigned int | channelsIn (void) const
| Return the number of input channels for the class.
unsigned int | channelsOut (void) const
| Return the number of output channels for the class.
virtual void | clear (void)
| Clears all internal states of the filter.
void | setGain (StkFloat gain)
| Set the filter gain.
StkFloat | getGain (void) const
| Return the current filter gain.
StkFloat | phaseDelay (StkFloat frequency)
| Return the filter phase delay at the specified frequency.
const StkFrames & | lastFrame (void) const
| Return an StkFrames reference to the last output sample frame.
virtual StkFrames & | tick (StkFrames &frames, unsigned int channel=0)=0
| Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.
Public Member Functions inherited from stk::Stk
void | ignoreSampleRateChange (bool ignore=true)
| A function to enable/disable the automatic updating of class data when the STK sample rate changes.

## Additional Inherited Members
Static Public Member Functions inherited from stk::Stk
static StkFloat | sampleRate (void)
| Static method that returns the current STK sample rate.
static void | setSampleRate (StkFloat rate)
| Static method that sets the STK sample rate.
static void | clear_alertList ()
| Static method that frees memory from alertList_.
static std::string | rawwavePath (void)
| Static method that returns the current rawwave path.
static void | setRawwavePath (std::string path)
| Static method that sets the STK rawwave path.
static void | swap16 (unsigned char *ptr)
| Static method that byte-swaps a 16-bit data type.
static void | swap32 (unsigned char *ptr)
| Static method that byte-swaps a 32-bit data type.
static void | swap64 (unsigned char *ptr)
| Static method that byte-swaps a 64-bit data type.
static void | sleep (unsigned long milliseconds)
| Static cross-platform method to sleep for a number of milliseconds.
static bool | inRange (StkFloat value, StkFloat min, StkFloat max)
| Static method to check whether a value is within a specified range.
static void | handleError (const char *message, StkError::Type type)
| Static function for error reporting and handling using c-strings.
static void | handleError (std::string message, StkError::Type type)
| Static function for error reporting and handling using c++ strings.
static void | showWarnings (bool status)
| Toggle display of WARNING and STATUS messages.
static void | printErrors (bool status)
| Toggle display of error messages before throwing exceptions.
Static Public Attributes inherited from stk::Stk
static const StkFormat | STK_SINT8
static const StkFormat | STK_SINT16
static const StkFormat | STK_SINT24
static const StkFormat | STK_SINT32
static const StkFormat | STK_FLOAT32
static const StkFormat | STK_FLOAT64
Protected Member Functions inherited from stk::Stk
| Stk (void)
| Default constructor.
virtual | ~Stk (void)
| Class destructor.
virtual void | sampleRateChanged (StkFloat newRate, StkFloat oldRate)
| This function should be implemented in subclasses that depend on the sample rate.
void | addSampleRateAlert (Stk *ptr)
| Add class pointer to list for sample rate change notification.
void | removeSampleRateAlert (Stk *ptr)
| Remove class pointer from list for sample rate change notification.
void | handleError (StkError::Type type) const
| Internal function for error reporting that assumes message in `oStream_` variable.

## Detailed Description

STK biquad (two-pole, two-zero) filter class.

This class implements a two-pole, two-zero digital filter. Methods are provided for creating a resonance or notch in the frequency response while maintaining a constant filter gain.

Formulae used calculate coefficients for lowpass, highpass, bandpass, bandreject and allpass are found on pg. 55 of Udo Zölzer's "DAFX - Digital Audio Effects" (2011 2nd ed).

by Perry R. Cook and Gary P. Scavone, 1995–2023.

## Member Function Documentation

## ◆ setResonance()

void stk::BiQuad::setResonance | ( | StkFloat | frequency,
|  | StkFloat | radius,
|  | bool | normalize = `false`
| ) |  |

Sets the filter coefficients for a resonance at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate poles with the given frequency (in Hz) and radius from the z-plane origin. If normalize is true, the filter zeros are placed at z = 1, z = -1, and the coefficients are then normalized to produce a constant unity peak gain (independent of the filter gain parameter). The resulting filter frequency response has a resonance at the given frequency. The closer the poles are to the unit-circle (radius close to one), the narrower the resulting resonance width. An unstable filter will result for radius >= 1.0. The frequency value should be between zero and half the sample rate.

## ◆ setNotch()

void stk::BiQuad::setNotch | ( | StkFloat | frequency,
|  | StkFloat | radius
| ) |  |

Set the filter coefficients for a notch at frequency (in Hz).

This method determines the filter coefficients corresponding to two complex-conjugate zeros with the given frequency (in Hz) and radius from the z-plane origin. No filter normalization is attempted. The frequency value should be between zero and half the sample rate. The radius value should be positive.

## ◆ setLowPass()

void stk::BiQuad::setLowPass | ( | StkFloat | fc,
|  | StkFloat | Q = `RECIP_SQRT_2`
| ) |  |

Set the filter coefficients for a low-pass with cutoff frequency fc (in Hz) and Q-factor Q.

This method determines the filter coefficients corresponding to a low-pass filter with cutoff placed at fc, where sloping behaviour and resonance are determined by Q. The default value for Q is 1/sqrt(2), resulting in a gradual attenuation of frequencies higher than fc without added resonance. Values greater than this will more aggressively attenuate frequencies above fc while also adding a resonance at fc. Values less than this will result in a more gradual attenuation of frequencies above fc, but will also attenuate frequencies below fc as well. Both fc and Q must be positive.

## ◆ setHighPass()

void stk::BiQuad::setHighPass | ( | StkFloat | fc,
|  | StkFloat | Q = `RECIP_SQRT_2`
| ) |  |

Set the filter coefficients for a high-pass with cutoff frequency fc (in Hz) and Q-factor Q.

This method determines the filter coefficients corresponding to a high-pass filter with cutoff placed at fc, where sloping behaviour and resonance are determined by Q. The default value for Q is 1/sqrt(2), resulting in a gradual attenuation of frequencies lower than fc without added resonance. Values greater than this will more aggressively attenuate frequencies below fc while also adding a resonance at fc. Values less than this will result in a more gradual attenuation of frequencies below fc, but will also attenuate frequencies above fc as well. Both fc and Q must be positive.

## ◆ setBandPass()

void stk::BiQuad::setBandPass | ( | StkFloat | fc,
|  | StkFloat | Q
| ) |  |

Set the filter coefficients for a band-pass centered at fc (in Hz) with Q-factor Q.

This method determines the filter coefficients corresponding to a band-pass filter with pass-band centered at fc, where band width and slope a determined by Q. Values for Q that are less than 1.0 will attenuate frequencies above and below fc more gradually, resulting in a convex slope and a wider band. Values for Q greater than 1.0 will attenuate frequencies above and below fc more aggressively, resulting in a concave slope and a narrower band. Both fc and Q must be positive.

## ◆ setBandReject()

void stk::BiQuad::setBandReject | ( | StkFloat | fc,
|  | StkFloat | Q
| ) |  |

Set the filter coefficients for a band-reject centered at fc (in Hz) with Q-factor Q.

This method determines the filter coefficients corresponding to a band-reject filter with stop-band centered at fc, where band width and slope are determined by Q. Values for Q that are less than 1.0 will yield a wider band with greater attenuation of fc. Values for Q greater than 1.0 will yield a narrower band with less attenuation of fc. Both fc and Q must be positive.

## ◆ setAllPass()

void stk::BiQuad::setAllPass | ( | StkFloat | fc,
|  | StkFloat | Q
| ) |  |

Set the filter coefficients for an all-pass centered at fc (in Hz) with Q-factor Q.

This method determines the filter coefficients corresponding to an all-pass filter whose phase response crosses -pi radians at fc. High values for Q will result in a more instantaenous shift in phase response at fc. Lower values will result in a more gradual shift in phase response around fc. Both fc and Q must be positive.

## ◆ setEqualGainZeroes()

void stk::BiQuad::setEqualGainZeroes | ( | void |  | ) |

Sets the filter zeroes for equal resonance gain.

When using the filter as a resonator, zeroes places at z = 1, z = -1 will result in a constant gain at resonance of 1 / (1 - R), where R is the pole radius setting.

## ◆ tick() [1/2]

StkFrames & stk::BiQuad::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0`
| ) |  |
| inlinevirtual

Take a channel of the StkFrames object as inputs to the filter and replace with corresponding outputs.

The StkFrames argument reference is returned. The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Filter.

206{
207#if defined(_STK_DEBUG_)
208 if ( channel >= frames.channels() ) {
209 oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
210 handleError( StkError::FUNCTION_ARGUMENT );
211 }
212#endif
213
214 StkFloat *samples = &frames[channel];
215 unsigned int hop = frames.channels();
216 for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
217 inputs_[0] = gain_ * *samples;
218 *samples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
219 *samples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
220 inputs_[2] = inputs_[1];
221 inputs_[1] = inputs_[0];
222 outputs_[2] = outputs_[1];
223 outputs_[1] = *samples;
224 }
225
226 lastFrame_[0] = outputs_[1];
227 return frames;
228}
stk::Stk::handleError
static void handleError(const char *message, StkError::Type type)
Static function for error reporting and handling using c-strings.

## ◆ tick() [2/2]

StkFrames & stk::BiQuad::tick | ( | StkFrames & | iFrames,
|  | StkFrames & | oFrames,
|  | unsigned int | iChannel = `0`,
|  | unsigned int | oChannel = `0`
| ) |  |
| inline

Take a channel of the `iFrames` object as inputs to the filter and write outputs to the `oFrames` object.

The `iFrames` object reference is returned. Each channel argument must be less than the number of channels in the corresponding StkFrames argument (the first channel is specified by 0). However, range checking is only performed if STK_DEBUG is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

231{
232#if defined(_STK_DEBUG_)
233 if ( iChannel >= iFrames.channels() || oChannel >= oFrames.channels() ) {
234 oStream_ << "BiQuad::tick(): channel and StkFrames arguments are incompatible!";
235 handleError( StkError::FUNCTION_ARGUMENT );
236 }
237#endif
238
239 StkFloat *iSamples = &iFrames[iChannel];
240 StkFloat *oSamples = &oFrames[oChannel];
241 unsigned int iHop = iFrames.channels(), oHop = oFrames.channels();
242 for ( unsigned int i=0; i<iFrames.frames(); i++, iSamples += iHop, oSamples += oHop ) {
243 inputs_[0] = gain_ * *iSamples;
244 *oSamples = b_[0] * inputs_[0] + b_[1] * inputs_[1] + b_[2] * inputs_[2];
245 *oSamples -= a_[2] * outputs_[2] + a_[1] * outputs_[1];
246 inputs_[2] = inputs_[1];
247 inputs_[1] = inputs_[0];
248 outputs_[2] = outputs_[1];
249 outputs_[1] = *oSamples;
250 }
251
252 lastFrame_[0] = outputs_[1];
253 return iFrames;
254}

The documentation for this class was generated from the following file:

- BiQuad.h

The Synthesis ToolKit in C++ (STK)
©1995--2023 Perry R. Cook and Gary P. Scavone. All Rights Reserved.